## mingw-w64-elisa-24.08.1-1.src.tar.zst

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015 (c) Matthieu Gallien <matthieu_gallien@yahoo.fr>
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.16)

# KDE Applications version, managed by release script.
set(RELEASE_SERVICE_VERSION_MAJOR "24")
set(RELEASE_SERVICE_VERSION_MINOR "08")
set(RELEASE_SERVICE_VERSION_MICRO "1")
set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

project(elisa
    VERSION ${RELEASE_SERVICE_VERSION}
    LANGUAGES CXX)

set(REQUIRED_KF_VERSION "6.3")
set(REQUIRED_KA_VERSION "0.11.76") # KirigamiAddons Version
find_package(ECM ${REQUIRED_KF_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(ECMInstallIcons)
include(FeatureSummary)
include(ECMAddAppIcon)
include(ECMAddTests)
include(ECMQtDeclareLoggingCategory)
include(ECMGenerateQmlTypes)
include(ECMAddAndroidApk)

set(REQUIRED_QT_VERSION "6.5.0")
find_package(Qt6 ${REQUIRED_QT_VERSION} CONFIG REQUIRED Core Network Qml Quick Test Sql Multimedia Svg Gui Widgets QuickTest Concurrent QuickControls2)

find_package(Qt6Core ${REQUIRED_QT_VERSION} CONFIG REQUIRED Private)



if (NOT WIN32 AND NOT ANDROID)
    find_package(Qt6DBus ${REQUIRED_QT_VERSION} CONFIG QUIET)
    set_package_properties(Qt6DBus PROPERTIES
        DESCRIPTION "Qt6 DBus is needed to provide MPris2 interface to allow remote control by the desktop workspace."
        TYPE OPTIONAL)
endif()

if (Qt6DBus_FOUND)
set(QtDBus_FOUND 1)
endif()

find_package(Qt6QuickWidgets ${REQUIRED_QT_VERSION} CONFIG QUIET)
set_package_properties(Qt6QuickWidgets PROPERTIES
    DESCRIPTION "Qt6 Quick Widgets is needed at runtime to provide the interface."
    TYPE RUNTIME)

find_package(Qt6QuickControls2 ${REQUIRED_QT_VERSION} CONFIG QUIET)
set_package_properties(Qt6QuickControls2 PROPERTIES
    DESCRIPTION "Qt6 Quick Controls version 2 is needed at runtime to provide the interface."
    TYPE RUNTIME)

find_package(KF6Kirigami ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF6Kirigami PROPERTIES
    DESCRIPTION "KF Kirigami is needed to provide the mobile UI components."
    TYPE REQUIRED)

find_package(KF6KirigamiAddons ${REQUIRED_KA_VERSION} CONFIG QUIET)
set_package_properties(KF6KirigamiAddons PROPERTIES
    DESCRIPTION "KF KirigamiAddons is needed to provide the about KDE dialogue."
    TYPE REQUIRED)

find_package(KF6I18n ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF6I18n PROPERTIES
    DESCRIPTION "KF text internationalization library."
    TYPE REQUIRED)

find_package(KF6CoreAddons ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF6CoreAddons PROPERTIES
    DESCRIPTION "Qt addon library with a collection of non-GUI utilities."
    TYPE REQUIRED)

find_package(KF6IconThemes ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF6IconThemes PROPERTIES
    DESCRIPTION "Support for icon themes."
    TYPE REQUIRED)

find_package(KF6FileMetaData ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF6FileMetaData PROPERTIES
    DESCRIPTION "Provides a simple library for extracting metadata."
    TYPE RECOMMENDED)

find_package(KF6XmlGui ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF6XmlGui PROPERTIES
    DESCRIPTION "Framework for managing menu and toolbar actions."
    TYPE RECOMMENDED)

find_package(KF6Config ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF6Config PROPERTIES
    DESCRIPTION "Persistent platform-independent application settings."
    TYPE REQUIRED)

find_package(KF6ColorScheme ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF6ColorScheme PROPERTIES
    DESCRIPTION "Allows changing the app's color scheme."
    TYPE REQUIRED)

find_package(KF6Crash ${REQUIRED_KF_VERSION} CONFIG QUIET)
set_package_properties(KF6Crash PROPERTIES
    DESCRIPTION "Graceful handling of application crashes."
    TYPE OPTIONAL)

if (NOT WIN32 AND NOT ANDROID)
    find_package(KF6DBusAddons ${REQUIRED_KF_VERSION} CONFIG QUIET)
    set_package_properties(KF6DBusAddons PROPERTIES
        DESCRIPTION "Convenience classes for D-Bus."
        TYPE OPTIONAL)
endif()

if (NOT ANDROID)
    find_package(KF6KIO ${REQUIRED_KF_VERSION} CONFIG QUIET)
    set_package_properties(KF6KIO PROPERTIES
        DESCRIPTION "File management libraries used for file browsing."
        TYPE REQUIRED)
    find_package(KF6QQC2DesktopStyle ${REQUIRED_KF_VERSION} CONFIG QUIET)
    set_package_properties(KF6QQC2DesktopStyle PROPERTIES
        DESCRIPTION "KDE QtQuick style for desktop"
        TYPE REQUIRED)
endif()

find_package(UPNPQT CONFIG QUIET)
set_package_properties(UPNPQT PROPERTIES
    DESCRIPTION "UPNP layer build with Qt. UPnP support is currently broken. You should probably avoid this dependency."
    URL "https://gitlab.com/homeautomationqt/upnp-player-qt"
    TYPE OPTIONAL)

if (UPNPQT_FOUND)
    message(WARNING "UPnP support is experimental and may not work.")
endif()

find_package(LIBVLC QUIET)
set_package_properties(LIBVLC PROPERTIES
    DESCRIPTION "libvlc allows to play music in Elisa (otherwise it will use QtMultimedia)"
    URL "https://www.videolan.org/vlc/libvlc.html"
    TYPE RECOMMENDED)

include(FeatureSummary)
include(GenerateExportHeader)
include(ECMSetupVersion)
include(ECMGenerateHeaders)
include(ECMGenerateDBusServiceFile)
include(CMakePackageConfigHelpers)
include(ECMDeprecationSettings)

set(KFXmlGui_FOUND ${KF6XmlGui_FOUND})
set(KFCrash_FOUND ${KF6Crash_FOUND})
set(KFDBusAddons_FOUND ${KF6DBusAddons_FOUND})
set(KFKIO_FOUND ${KF6KIO_FOUND})
set(KFFileMetaData_FOUND ${KF6FileMetaData_FOUND})

configure_file(config-upnp-qt.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-upnp-qt.h)

ecm_setup_version(${RELEASE_SERVICE_VERSION}
    VARIABLE_PREFIX ELISA
    VERSION_HEADER elisa-version.h)

set(QML_IMPORT_PATH ${CMAKE_BINARY_DIR}/bin CACHE STRING "" FORCE)

ecm_set_disabled_deprecation_versions(
    QT 6.1.0
    KF 6.4
)


add_subdirectory(src)
add_subdirectory(icons)
if (BUILD_TESTING)
    add_subdirectory(autotests)
endif()

if (KF6DBusAddons_FOUND)
    ecm_generate_dbus_service_file(
        NAME org.kde.elisa
        EXECUTABLE ${KDE_INSTALL_FULL_BINDIR}/elisa
        DESTINATION ${KDE_INSTALL_DBUSSERVICEDIR}
    )
    set(ELISA_DBUSACTIVATABLE "DBusActivatable=true")
else()
    set(ELISA_DBUSACTIVATABLE)
endif()

configure_file(org.kde.elisa.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/org.kde.elisa.desktop @ONLY)
install(
    PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/org.kde.elisa.desktop
    DESTINATION ${KDE_INSTALL_APPDIR}
)

install(
    FILES org.kde.elisa.appdata.xml
    DESTINATION ${KDE_INSTALL_METAINFODIR}
)

ki18n_install(po)

install(FILES elisa.categories DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR})

if (ANDROID)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/android/version.gradle.in ${CMAKE_BINARY_DIR}/version.gradle)
endif()

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2016 (c) Matthieu Gallien <matthieu_gallien@yahoo.fr>
#
# SPDX-License-Identifier: LGPL-3.0-or-later

include_directories(${elisa_BINARY_DIR})

set(elisaLib_SOURCES
    colorschemepreviewimageprovider.cpp
    mediaplaylist.cpp
    mediaplaylistproxymodel.cpp
    progressindicator.cpp
    qmlforeigntypes.h
    databaseinterface.cpp
    datatypes.cpp
    musiclistenersmanager.cpp
    managemediaplayercontrol.cpp
    manageheaderbar.cpp
    manageaudioplayer.cpp
    trackslistener.cpp
    elisaapplication.cpp
    modeldataloader.cpp
    elisautils.cpp
    abstractfile/abstractfilelistener.cpp
    abstractfile/abstractfilelisting.cpp
    filescanner.cpp
    filewriter.cpp
    viewmanager.cpp
    powermanagementinterface.cpp
    file/filelistener.cpp
    file/localfilelisting.cpp
    models/datamodel.cpp
    models/abstractmediaproxymodel.cpp
    models/gridviewproxymodel.cpp
    models/trackmetadatamodel.cpp
    models/editabletrackmetadatamodel.cpp
    models/trackcontextmetadatamodel.cpp
    models/viewsmodel.cpp
    models/viewsproxymodel.cpp
    models/lyricsmodel.cpp
    viewslistdata.cpp
    viewconfigurationdata.cpp
    localFileConfiguration/elisaconfigurationdialog.cpp
)

set(elisaLib_INCLUDEDIRS
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/abstractfile
    ${CMAKE_CURRENT_SOURCE_DIR}/file
    ${CMAKE_CURRENT_SOURCE_DIR}/localFileConfiguration
    ${CMAKE_CURRENT_SOURCE_DIR}/models
)

ecm_qt_declare_logging_category(elisaLib_SOURCES
    HEADER "indexersManager.h"
    IDENTIFIER "orgKdeElisaIndexersManager"
    CATEGORY_NAME "org.kde.elisa.indexers.manager"
    DEFAULT_SEVERITY Info
    )

ecm_qt_declare_logging_category(elisaLib_SOURCES
    HEADER "databaseLogging.h"
    IDENTIFIER "orgKdeElisaDatabase"
    CATEGORY_NAME "org.kde.elisa.database"
    DEFAULT_SEVERITY Info
    )

ecm_qt_declare_logging_category(elisaLib_SOURCES
    HEADER "abstractfile/indexercommon.h"
    IDENTIFIER "orgKdeElisaIndexer"
    CATEGORY_NAME "org.kde.elisa.indexer"
    DEFAULT_SEVERITY Info
    )

ecm_qt_declare_logging_category(elisaLib_SOURCES
    HEADER "models/modelLogging.h"
    IDENTIFIER "orgKdeElisaModel"
    CATEGORY_NAME "org.kde.elisa.model"
    DEFAULT_SEVERITY Info
    )

ecm_qt_declare_logging_category(elisaLib_SOURCES
    HEADER "playListLogging.h"
    IDENTIFIER "orgKdeElisaPlayList"
    CATEGORY_NAME "org.kde.elisa.playlist"
    DEFAULT_SEVERITY Info
    )

ecm_qt_declare_logging_category(elisaLib_SOURCES
    HEADER "viewsLogging.h"
    IDENTIFIER "orgKdeElisaViews"
    CATEGORY_NAME "org.kde.elisa.views"
    DEFAULT_SEVERITY Info
    )

ecm_qt_declare_logging_category(elisaLib_SOURCES
    HEADER "playerLogging.h"
    IDENTIFIER "orgKdeElisaPlayer"
    CATEGORY_NAME "org.kde.elisa.player"
    DEFAULT_SEVERITY Info
    )

ecm_qt_declare_logging_category(elisaLib_SOURCES
    HEADER "powerManagementLogging.h"
    IDENTIFIER "orgKdeElisaPowerManagement"
    CATEGORY_NAME "org.kde.elisa.powermanagement"
    DEFAULT_SEVERITY Info
    )

if (LIBVLC_FOUND)
    ecm_qt_declare_logging_category(elisaLib_SOURCES
        HEADER "vlcLogging.h"
        IDENTIFIER "orgKdeElisaPlayerVlc"
        CATEGORY_NAME "org.kde.elisa.player.vlc"
        DEFAULT_SEVERITY Info
        )

    set(elisaLib_SOURCES
        ${elisaLib_SOURCES}
        audiowrapper_libvlc.cpp
        )
else()
    ecm_qt_declare_logging_category(elisaLib_SOURCES
        HEADER "qtMultimediaLogging.h"
        IDENTIFIER "orgKdeElisaPlayerQtMultimedia"
        CATEGORY_NAME "org.kde.elisa.player.qtMultimedia"
        DEFAULT_SEVERITY Info
        )

    set(elisaLib_SOURCES
        ${elisaLib_SOURCES}
        audiowrapper_qtmultimedia.cpp
        )
endif()

if (WIN32)
    ecm_qt_declare_logging_category(elisaLib_SOURCES
        HEADER "windowsLogging.h"
        IDENTIFIER "orgKdeElisaWindows"
        CATEGORY_NAME "org.kde.elisa.windows"
        DEFAULT_SEVERITY Info
        )

    set(elisaLib_SOURCES
        ${elisaLib_SOURCES}
        windows/taskbarmanager.cpp
    )
    set(elisaLib_INCLUDEDIRS
        ${elisaLib_INCLUDEDIRS}
        ${CMAKE_CURRENT_SOURCE_DIR}/windows
    )
endif()

if (ANDROID)
    ecm_qt_declare_logging_category(elisaLib_SOURCES
        HEADER "android/androidcommon.h"
        IDENTIFIER "orgKdeElisaAndroid"
        CATEGORY_NAME "org.kde.elisa.android"
        DEFAULT_SEVERITY Info
        )

    set(elisaLib_SOURCES
        ${elisaLib_SOURCES}
        android/androidcoverimageprovider.cpp
        android/androidmusiclistener.cpp
        android/androidfilelisting.cpp
        )
    set(elisaLib_INCLUDEDIRS
        ${elisaLib_INCLUDEDIRS}
        ${CMAKE_CURRENT_SOURCE_DIR}/android
    )
endif()

if (KF6FileMetaData_FOUND)
    set(elisaLib_SOURCES
        ${elisaLib_SOURCES}
        embeddedcoverageimageprovider.cpp
    )
endif()

if (KF6KIO_FOUND)
    set(elisaLib_SOURCES
        ${elisaLib_SOURCES}
        models/filebrowsermodel.cpp
        models/filebrowserproxymodel.cpp
        )
endif()

if (Qt6DBus_FOUND)
    set(elisaLib_SOURCES
        ${elisaLib_SOURCES}
        mpris2/mpris2.cpp
        mpris2/mediaplayer2.cpp
        mpris2/mediaplayer2player.cpp
        )
    set(elisaLib_INCLUDEDIRS
        ${elisaLib_INCLUDEDIRS}
        ${CMAKE_CURRENT_SOURCE_DIR}/mpris2
    )
endif()

if (UPNPQT_FOUND)
    set(elisaLib_SOURCES
        ${elisaLib_SOURCES}
        upnp/upnpcontrolcontentdirectory.cpp
        upnp/upnpcontentdirectorymodel.cpp
        upnp/upnpcontrolconnectionmanager.cpp
        upnp/upnpcontrolmediaserver.cpp
        upnp/didlparser.cpp
        upnp/upnplistener.cpp
        upnp/upnpdiscoverallmusic.cpp
        )
    set(elisaLib_INCLUDEDIRS
        ${CMAKE_CURRENT_SOURCE_DIR}/upnp
    )
endif()

kconfig_add_kcfg_files(elisaLib_SOURCES ../src/elisa_settings.kcfgc GENERATE_MOC )
set(elisaLib_SOURCES
    ${elisaLib_SOURCES}
    ../src/elisa_core.kcfg
    )

add_library(elisaLib ${elisaLib_SOURCES})
target_link_libraries(elisaLib
    LINK_PUBLIC
    Qt::Multimedia Qt::Qml KF6::ConfigGui
    LINK_PRIVATE
    Qt::Core Qt::Quick Qt::Sql Qt::Widgets Qt::Concurrent
    KF6::I18n KF6::CoreAddons
    KF6::ConfigCore
    KF6::ColorScheme)

if (KF6FileMetaData_FOUND)
    target_link_libraries(elisaLib
        LINK_PRIVATE
        KF6::FileMetaData
        )
endif()

if (KF6KIO_FOUND)
    target_link_libraries(elisaLib
        LINK_PUBLIC
        KF6::KIOCore KF6::KIOFileWidgets KF6::KIOWidgets
        )
endif()

if (KF6XmlGui_FOUND)
    target_link_libraries(elisaLib
        LINK_PUBLIC
        KF6::XmlGui
        )
endif()

if (Qt6DBus_FOUND)
    target_link_libraries(elisaLib
        LINK_PUBLIC
        Qt::DBus
        )

    if (KF6DBusAddons_FOUND)
        target_link_libraries(elisaLib
            LINK_PUBLIC
            KF6::DBusAddons
            )
    endif()
endif()

if (LIBVLC_FOUND)
    target_include_directories(elisaLib
        PRIVATE
        ${LIBVLC_INCLUDE_DIR}
        )

    target_link_libraries(elisaLib
        LINK_PRIVATE
        ${LIBVLC_LIBRARY}
        )
endif()

if (ANDROID)
    target_link_libraries(elisaLib PRIVATE Qt6::CorePrivate Qt6::Quick jnigraphics)
endif()

generate_export_header(elisaLib BASE_NAME ElisaLib EXPORT_FILE_NAME elisaLib_export.h)

set_target_properties(elisaLib PROPERTIES
    VERSION 0.1
    SOVERSION 0
    EXPORT_NAME ElisaLib
    )

if (NOT APPLE AND NOT WIN32)
    install(TARGETS elisaLib
        LIBRARY DESTINATION ${KDE_INSTALL_FULL_LIBDIR}/elisa NAMELINK_SKIP
        RUNTIME DESTINATION ${KDE_INSTALL_FULL_LIBDIR}/elisa
        BUNDLE DESTINATION ${KDE_INSTALL_FULL_LIBDIR}/elisa
        )
else()
    install(TARGETS elisaLib ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
endif()

target_include_directories(elisaLib PRIVATE ${elisaLib_INCLUDEDIRS})

set_source_files_properties(windows/WindowsTheme.qml PROPERTIES
    QT_RESOURCE_ALIAS qml/+windows/WindowsTheme.qml
)

set_source_files_properties(windows/PlatformIntegration.qml PROPERTIES
    QT_RESOURCE_ALIAS qml/+windows/PlatformIntegration.qml
)

set_source_files_properties(android/PlatformIntegration.qml PROPERTIES
    QT_RESOURCE_ALIAS qml/+android/PlatformIntegration.qml
)

set_source_files_properties(android/qtquickcontrols2.conf PROPERTIES
    QT_RESOURCE_ALIAS qml/+android/qtquickcontrols2.conf
)

qt_policy(SET QTP0001 NEW)
qt_add_qml_module(elisaLib
    URI org.kde.elisa
    QML_FILES
        android/PlatformIntegration.qml

        windows/PlatformIntegration.qml
        windows/WindowsTheme.qml

        qml/AbstractBrowserDelegate.qml
        qml/AbstractDataView.qml
        qml/AccessibleSlider.qml
        qml/ApplicationMenu.qml
        qml/BaseTheme.qml
        qml/BasicPlayListAlbumHeader.qml
        qml/ButtonWithToolTip.qml
        qml/ConfigurationDialog.qml
        qml/ContentView.qml
        qml/ContextView.qml
        qml/DataGridView.qml
        qml/DataTrackView.qml
        qml/DurationSlider.qml
        qml/ElisaMainWindow.qml
        qml/FlatButtonWithToolTip.qml
        qml/FooterBar.qml
        qml/GridBrowserDelegate.qml
        qml/HeaderBar.qml
        qml/ImageWithFallback.qml
        qml/LabelWithToolTip.qml
        qml/ListBrowserDelegate.qml
        qml/MediaPlayerControl.qml
        qml/MediaPlayListView.qml
        qml/MediaTrackMetadataDelegate.qml
        qml/MediaTrackMetadataForm.qml
        qml/MediaTrackMetadataView.qml
        qml/NativeGlobalMenu.qml
        qml/NativeGlobalMenuPlaylistModeItem.qml
        qml/NativeGlobalMenuShuffleModeItem.qml
        qml/NativeMenuItemFromAction.qml
        qml/NativeTrayMenu.qml
        qml/NavigationActionBar.qml
        qml/PlatformIntegration.qml
        qml/PlayListEntry.qml
        qml/PlaylistModeItem.qml
        qml/RatingStar.qml
        qml/SettingsForm.qml
        qml/ShuffleModeItem.qml
        qml/SimplePlayListView.qml
        qml/SortMenu.qml
        qml/Theme.qml
        qml/TrackBrowserDelegate.qml
        qml/TrackImportNotification.qml
        qml/TracksDiscHeader.qml
        qml/ViewSelector.qml
        qml/VolumeSlider.qml

        qml/mobile/MobileFooterBar.qml
        qml/mobile/MobileMediaTrackMetadataView.qml
        qml/mobile/MobileMinimizedPlayerControl.qml
        qml/mobile/MobilePlayListDelegate.qml
        qml/mobile/MobileSettingsPage.qml
        qml/mobile/MobileSidebar.qml
        qml/mobile/MobileTrackPlayer.qml
        qml/mobile/MobileVolumeButton.qml

        qml/shared/BasePlayerControl.qml
        qml/shared/BasePlayListDelegate.qml
    RESOURCES
        background.png
        qtquickcontrols2.conf
    )

if (Qt6Quick_FOUND AND Qt6Widgets_FOUND)

    set(elisa_SOURCES
        main.cpp
    )

    set(elisa_ICONS_PNG
        ../icons/128-apps-elisa.png
        ../icons/64-apps-elisa.png
        ../icons/48-apps-elisa.png
        ../icons/32-apps-elisa.png
        ../icons/22-apps-elisa.png
        ../icons/16-apps-elisa.png
        )

    # add icons to application sources, to have them bundled
    ecm_add_app_icon(elisa_SOURCES ICONS ${elisa_ICONS_PNG})

    add_executable(elisa ${elisa_SOURCES})

    target_include_directories(elisa PRIVATE ${KDSoap_INCLUDE_DIRS})

    target_link_libraries(elisa
        LINK_PRIVATE
        elisaLib
        Qt::Widgets Qt::QuickControls2
        KF6::I18n KF6::CoreAddons KF6::ConfigCore KF6::ConfigGui
        KF6::IconThemes
        )

    if (ANDROID)
        target_link_libraries(elisa
            PRIVATE
            Qt::Svg Qt::Sql Qt::Concurrent KF6::Kirigami Qt6::CorePrivate
        )
    endif()

    if (KF6Crash_FOUND)
        target_link_libraries(elisa
            LINK_PRIVATE
            KF6::Crash
            )
    endif()

    if (NOT APPLE AND NOT WIN32)
        set_target_properties(elisa PROPERTIES
            INSTALL_RPATH "${KDE_INSTALL_FULL_LIBDIR}/elisa;${CMAKE_INSTALL_RPATH}"
            )
    endif()

    install(TARGETS elisa ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
endif()

set(elisaImport_SOURCES
    elisaimport.cpp
    elisaimportapplication.cpp
    )

=== PKGBUILD ===
# Maintainer: Biswapriyo Nath <nathbappai@gmail.com>

source "$(dirname ${BASH_SOURCE[0]})"/../mingw-w64-PKGBUILD-common/kde-frameworks
_realname=elisa
pkgbase="mingw-w64-${_realname}"
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=24.08.1
pkgrel=1
pkgdesc="A simple music player aiming to provide a nice experience for its users (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
msys2_references=(
  'archlinux: elisa'
)
msys2_repository_url='https://invent.kde.org/multimedia/elisa/'
url='https://apps.kde.org/elisa/'
license=('spdx:LGPL-2.0-or-later')
depends=(
  "${MINGW_PACKAGE_PREFIX}-kcolorscheme"
  "${MINGW_PACKAGE_PREFIX}-kconfig"
  "${MINGW_PACKAGE_PREFIX}-kconfigwidgets"
  "${MINGW_PACKAGE_PREFIX}-kcoreaddons"
  "${MINGW_PACKAGE_PREFIX}-kcrash"
  "${MINGW_PACKAGE_PREFIX}-kfilemetadata"
  "${MINGW_PACKAGE_PREFIX}-ki18n"
  "${MINGW_PACKAGE_PREFIX}-kiconthemes"
  "${MINGW_PACKAGE_PREFIX}-kio"
  "${MINGW_PACKAGE_PREFIX}-kirigami"
  "${MINGW_PACKAGE_PREFIX}-kirigami-addons"
  "${MINGW_PACKAGE_PREFIX}-kitemviews"
  "${MINGW_PACKAGE_PREFIX}-kxmlgui"
  "${MINGW_PACKAGE_PREFIX}-qqc2-desktop-style"
  "${MINGW_PACKAGE_PREFIX}-qt6-5compat"
  "${MINGW_PACKAGE_PREFIX}-qt6-base"
  "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
  "${MINGW_PACKAGE_PREFIX}-qt6-multimedia"
  "${MINGW_PACKAGE_PREFIX}-vlc"
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-extra-cmake-modules"
  "${MINGW_PACKAGE_PREFIX}-gettext-tools"
  "${MINGW_PACKAGE_PREFIX}-icoutils"
  "${MINGW_PACKAGE_PREFIX}-kdoctools"
  "${MINGW_PACKAGE_PREFIX}-ninja"
)
groups=(
  "${MINGW_PACKAGE_PREFIX}-kde-applications"
  "${MINGW_PACKAGE_PREFIX}-kde-multimedia"
)
source=("https://download.kde.org/stable/release-service/${pkgver}/src/${_realname}-${pkgver}.tar.xz"{,.sig})
sha256sums=('cedf6dc9e1d81113e6599041d09b52d4ddf06c94167bdcdcc9b8cb1c66c0a24a'
            'SKIP')
validpgpkeys=(CA262C6C83DE4D2FB28A332A3A6A4DB839EAA6D7  # Albert Astals Cid <aacid@kde.org>
              F23275E4BF10AFC1DF6914A6DBD2CE893E2D1C87  # Christoph Feck <cfeck@kde.org>
              D81C0CB38EB725EF6691C385BB463350D6EF31EF) # Heiko Becker <heiko.becker@kde.org>

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  _kde_build_env
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_KDE_INSTALL_DIRS[@]}" \
      -DBUILD_QCH=OFF \
      -DBUILD_TESTING=OFF \
      "${_extra_config[@]}" \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"
}
